Graphics3D 800,600,0,2
AppTitle "Infektion"
SetBuffer BackBuffer()
Collisions 1,1,2,2
Local Timer=CreateTimer(58)
Local MX,MY,MDown,MHitR,Mhitm,BS,Font,P.Player,NoWatched,Watched,i
Global U.Unit,B.Building,UnitID%,BuildingID%
Local TipCD=MilliSecs()
Font=LoadFont("Arial"):SetFont Font

Global Camera=CreateCamera()
CameraClsColor Camera,240,20,30
PositionEntity Camera,0,14,0
RotateEntity Camera,75,0,0
CameraViewport Camera,0,0,658,600

Local Light=CreateLight()
Local NoPic=CreateImage(146,235)
Local Drawn=NoPic

Global Ring=LoadMesh("gfx/Ring.b3d")
HideEntity Ring

BS=LoadImage("gfx/SB.png")

Dim Tips$(7)
Local File_Tip=OpenFile("Tipps.txt")
For ReadTip=0 To 7
	Tips$(ReadTip)=ReadLine$(File_Tip)
Next
CloseFile File_Tip
Dim Player(2)
For CP=1 To 2
	P.Player=New Player
	P\ID=CP
	P\Name$="Player "+CP
	Player(CP)=Handle(P.Player)
Next

Dim UnitDescription$(4,7)

For PE=1 To 4
	O=OpenFile("data/"+PE+".txt")
	For TR=0 To 7
		UnitDescription$(PE,TR)=ReadLine$(O)
	Next
	CloseFile O
Next

Local Plane=CreatePlane()
Local PlaneTex=LoadTexture("gfx/BE.jpg")
ScaleTexture PlaneTex,20,20
EntityTexture Plane,PlaneTex
EntityType Plane,1
EntityPickMode Plane, 2 

Dim MiniPics(10)
For Blab=1 To 10
	MiniPics(Blab)=LoadImage("gfx/S"+(Blab)+".png")
Next

Dim Units(4)
Units(0)=LoadAnimMesh("gfx/Schlitzer.b3d")
Units(1)=LoadAnimMesh("gfx/Bestrafer.b3d")
Units(2)=LoadAnimMesh("gfx/Makrophag.b3d")
Units(3)=LoadAnimMesh("gfx/Robosom.b3d")
Units(4)=LoadAnimMesh("gfx/Stachelwalzer.b3d")
For UP=0 To 4
	ExtractAnimSeq (Units(UP),1,24)
	ExtractAnimSeq (Units(UP),25,48)
	ExtractAnimSeq (Units(UP),49,72)
	ExtractAnimSeq (Units(UP),73,96)
	HideEntity Units(UP)
Next

Dim Pics(4)
Pics(0)=LoadImage("gfx/Slicer.png")
Pics(1)=LoadImage("gfx/Punisher.png")
Pics(2)=LoadImage("gfx/Makrophag.png")
Pics(3)=LoadImage("gfx/Robosom.png")
Pics(4)=LoadImage("gfx/Stachelwalzer.png")

Dim Buildings(2)
Buildings(0)=LoadMesh("gfx/Schlitzerdom.b3d")
Buildings(1)=LoadMesh("gfx/Makrophagpool.b3d")
Buildings(2)=LoadMesh("gfx/Zentrale.b3d")
For UB=0 To 2
	HideEntity Buildings(UB)
Next
;Startthingys
For PP=1 To 5
	SpawnUnit(1,(PP-3)*3,-7,0,3,30,5,0.03,1,"110000000")
Next
BuildBuilding(0,0,1,0,2,3500,"000000001")
;Startthingys
While Not KeyDown(1)
	Cls
	If Rand(1,100)=10
		P.Player=Object.Player(2)
		P\Protein=100000
		SpawnUnit(2,0+Rnd(-3,3),100+Rnd(-3,3)-10,150,0,50,12,0.1,1,111000000)
	Order_Move(U.Unit,0,0)
End If
	
	MX=MouseX()
	MY=MouseY()
	MDown=MouseDown(1)
	MHitR=MouseHit(2)
	Mhitm=MouseHit(3)
	
	;Camera Movement
	If MX<0+25 Then TranslateEntity Camera,-0.33,0,0
	If MX>800-25 Then TranslateEntity Camera,0.33,0,0
	If MY<0+25 Then TranslateEntity Camera,0,0,0.33
	If MY>600-25 Then TranslateEntity Camera,0,0,-0.33
	TurnP#=TurnP#-MouseZSpeed()
	MoveEntity Camera,0,0,-TurnP#
	If EntityY(Camera)<8.5 Then TurnP#=TurnP#+0.15:TranslateEntity Camera,0,8-EntityY(Camera),0
	If EntityY(Camera)>24.5 Then TurnP#=TurnP#-0.15:TranslateEntity Camera,0,25-EntityY(Camera),0
	TurnP#=TurnP#*0.8
;/Camera Movement
	UpdateWorld
	RenderWorld
;Mendingsie
	DrawImage Drawn,650,350
	DrawImage BS,600,0
	
	If HP<>0 And MaxHp<>0
		Text 710,550,HP+" / "+MaxHP
	End If
	
	;Unit Management
	For U.Unit=Each Unit
		If U\Picked=1 Then 
			TurnEntity U\Ring,0,1.5,0:
			HP=U\Hitpoints
			MaxHP=U\MaxHitpoints
			For B.Building=Each Building
				B\Picked=0
			Next
		End If
		If U\Dead=-1 Then
			U\Hitpoints=U\Hitpoints+1
			TSc#=U\Hitpoints#/U\MaxHitpoints#
			EntityAlpha U\Mesh,TSc#
			EntityAlpha U\Ring,TSc#
			If TSc#>=1 Then U\Dead=0
		End If
			RotateEntity U\Mesh,0,EntityYaw#(U\Mesh),EntityRoll#(U\Mesh)
			TranslateEntity U\Mesh,0,0-EntityY#(U\Mesh),0
			CameraProject Camera,EntityX#(U\Mesh),0,EntityZ#(U\Mesh)
			
			If ProjectedX#()<635 Then 
				Color 20,20,20
				Rect ProjectedX#()-1,ProjectedY#()-1,22,8
				Color 255-255*(U\Hitpoints#/U\MaxHitpoints#),255*(U\Hitpoints#/U\MaxHitpoints#),20
				Rect ProjectedX#(),ProjectedY#(),U\Hitpoints#/(U\MaxHitpoints#/20.0),6
				
				Color 20,20,20
				For Cell=1 To 5
					Rect ProjectedX#()+Cell*4,ProjectedY#(),1,7
				Next
				Color 255,255,255
			End If
				If EntityDistance(U\Mesh,U\Target)>3 And U\Hitpoints>0 And U\Dead=0 Then 
					MoveEntity U\Mesh,0,0,U\Movespeed#
					If Animating(U\Mesh)=0 Then Animate U\Mesh,3,0.43,1:U\AnimationMode=1
				End If
				If EntityDistance(U\Mesh,U\Target)<3 And U\Hitpoints>0 Then U\ForceCommand=0
				For B.Building=Each Building
					If U\Owner<>B\Owner
						If EntityDistance (U\Mesh,B\Mesh)<22 And U\ForceCommand=0 And B\Hitpoints>0 Then
							PositionEntity U\Target,EntityX#(B\Mesh),0,EntityZ#(B\Mesh)
							U\Attack=1
							If EntityDistance(U\Mesh,U\Target)<10 And U\Attack=1 And U\Hitpoints>0 Then
								If U\AnimationMode<>2 Then Animate U\Mesh,3,0.5,2:U\AnimationMode=2
							End If
						End If
						;Schaden austeilen
						If U\AnimationMode=2
							If EntityDistance (U\Mesh,B\Mesh)<10 And AnimTime(U\Mesh)>6 And AnimTime(U\Mesh)<7 And Abs(DeltaYaw(U\Mesh,B\Mesh))<22 Then
								B\Hitpoints=B\Hitpoints-U\Damage
								
							End If
						End If
					End If
				Next
				For U2.Unit=Each Unit
					If U\Owner<>U2\Owner
						If EntityDistance (U\Mesh,U2\Mesh)<U\Range*2 And U\Dead=0 And U\ForceCommand=0 Then
							PositionEntity U\Target,EntityX#(U2\Mesh),0,EntityZ#(U2\Mesh)
							U\Attack=1
							If EntityDistance(U\Mesh,U\Target)<U\Range And U\Attack=1 And U2\Hitpoints>0 Then
								If U\AnimationMode<>2 Then Animate U\Mesh,3,0.5,2:U\AnimationMode=2
							End If
						End If
						;Schaden austeilen
						If U\AnimationMode=2
							If EntityDistance (U\Mesh,U2\Mesh)<U\Range And AnimTime(U\Mesh)>6 And AnimTime(U\Mesh)<7 And Abs(DeltaYaw(U\Mesh,U2\Mesh))<15 Then
								U2\Hitpoints=U2\Hitpoints-U\Damage
							End If
						End If
					End If
				Next
				If U\Dead=0 TurnEntity U\Mesh,0,DeltaYaw#(U\Mesh,U\Target)/10.0,0
					If U\Hitpoints<0  And U\AnimationMode<>3 Then Animate U\Mesh,3,0.43,3,1:U\AnimationMode=3:U\Attack=0:U\Dead=1
					
					Select U\AnimationMode
					Case 2;Attack
						U\Attack=0
						If Animating(U\Mesh)=0 Then
							U\AnimationMode=1
						End If
					Case 3;Die
						If Animating(U\Mesh)=0 Then
							FreeEntity U\Mesh
							Delete U.Unit
						End If
					Case 4;Stand
						
				End Select
	Next
	;/Unit Management
	;Building Management
	For B.Building=Each Building
		If B\Dead=-1 Then
			B\Hitpoints=B\Hitpoints+1
			TSc#=B\Hitpoints#/B\MaxHitpoints#
			PositionEntity B\Mesh,EntityX#(B\Mesh),-4.0+Tsc#*4.0,EntityZ#(B\Mesh)
			If TSc#>=1 Then B\Dead=0:	EntityType B\Mesh,1
		End If
		If B\Hitpoints<=0 Then B\Dead=1
	CameraProject Camera,EntityX#(B\Mesh),EntityY#(B\Mesh),EntityZ#(B\Mesh)
	If ProjectedX#()<635 Then 
		Color 20,20,20
		Rect ProjectedX#()-1,ProjectedY#()-1,42,14
		Color 255-255*(B\Hitpoints#/B\MaxHitpoints#),255*(B\Hitpoints#/B\MaxHitpoints#),20
		Rect ProjectedX#(),ProjectedY#(),B\Hitpoints#/(B\MaxHitpoints#/40.0),12
		Color 20,20,20
		For Cell=1 To 10
			Rect ProjectedX#()+Cell*4,ProjectedY#(),1,13
		Next
		Color 255,255,255
	End If
			For i=1 To 9
				If Mid(B\Spawn$,i,1)=1 Then
					Select i
						Case 1 ;RobOSom
							If B\Picked=1 And B\Dead=0 Then
				DrawImage MiniPics(1),665,85
				If MX>665 And MX<665+36 And MY>85 And MY<85+36 Then
					For Blub=0 To 7
						Text 672,255+10*Blub,UnitDescription$(i,Blub)
					Next
					If MHitR Then SpawnUnit(P\ID,EntityX#(B\Mesh)+Rnd(-3,3),EntityZ#(B\Mesh)+Rnd(-3,3)-10,50,3,30,5,0.03,1,"110000000")
				End If
			End If
			Case 2 ;Slicer
				If B\Picked=1 And B\Dead=0 Then
				DrawImage MiniPics(2),755,85
				If MX>755 And MX<755+36 And MY>85 And MY<85+36 Then
					For Blub=0 To 7
						Text 672,255+10*Blub,UnitDescription$(i,Blub)
					Next
					If MHitR Then SpawnUnit(P\ID,EntityX#(B\Mesh)+Rnd(-3,3),EntityZ#(B\Mesh)+Rnd(-3,3)-10,150,0,50,12,0.1,1,"000000000")
				End If
			End If
			Case 3 ;Punisher
				If B\Picked=1 And B\Dead=0 Then
				DrawImage MiniPics(3),710,85
				If MX>710 And MX<710+36 And MY>85 And MY<85+36 Then
					For Blub=0 To 7
						Text 672,255+10*Blub,UnitDescription$(i,Blub)
					Next
					If MHitR Then SpawnUnit(P\ID,EntityX#(B\Mesh)+Rnd(-3,3),EntityZ#(B\Mesh)+Rnd(-3,3)-10,500,1,350,35,0.05,1,"000000000")
				End If
			End If
			Case 4 ;Makrophage
				If B\Picked=1 And B\Dead=0 Then
				DrawImage MiniPics(4),665,125
				If MX>665 And MX<665+36 And MY>125 And MY<125+36 Then
					For Blub=0 To 7
						Text 672,255+10*Blub,UnitDescription$(i,Blub)
					Next
					If MHitR Then SpawnUnit(P\ID,EntityX#(B\Mesh),EntityZ#(B\Mesh)-10,600,2,350,35,0.05,1,"001000000")
				End If
			End If
			Case 9 
				If B\Picked=1 And B\Dead=0 Then
				DrawImage MiniPics(10),755,165
				If MX>755 And MX<755+36 And MY>165 And MY<165+36 Then
						Text 685,205,"Schlsselfigur"
						Text 695,215,"Passiv"
						Text 672,260,"Die Einheit ist eine "
						Text 672,270,"Schlsselfigur. Sind alle"
						Text 672,280,"tot, ist das Spiel zu Ende."
					End If
				End If
				Skill_KeyUnit(B\Owner)
				
		End Select
	End If
Next

	If B\Dead=1 Then
		TranslateEntity B\Mesh,0,-0.05,0
		RotateEntity B\Mesh,Rnd(-4,4),Rnd(-4,4),Rnd(-4,4)
		
		If EntityY#(B\Mesh)<-4 Then FreeEntity B\Mesh:Delete B.Building
	End If
Next
	;/Building Management
;Spieler
	;Startpunkte setzen
P.Player=Object.Player(1)
	For U.Unit=Each Unit
		If KeyDown(2) And U\AnimationMode<>2 And U\Owner=P\ID And U\Picked=1 Then Animate U\Mesh,3,0.5,2:U\AnimationMode=2
	Next
	If MDown=1 And Hold=0 Then
		StartX=MX
		StartY=MY
		Hold=1
	End If
	
	For U.Unit=Each Unit
		If U\Owner=P\ID
			For i=1 To 9
				If Mid(U\Skill$,i,1)=1 Then
					Select i
						Case 1
						If U\Picked=1
							DrawImage MiniPics(1),665,85
						If MX>665 And MX<665+36 And MY>85 And MY<85+36 Then
							Text 685,205,"Hauptzentrale"
							Text 695,215,"4000 Proteine"
							Text 672,260,"Die Hauptzentrale verwaltet alles"
							Text 672,270,"und kann Robosome erzeugen."
							If MHitR Then BuildBuilding(EntityX#(U\Mesh),EntityZ#(U\Mesh),1,1200,2,3500,"100000000")
						End If
						DrawImage MiniPics(4),710,85
						If MX>710 And MX<710+36 And MY>85 And MY<85+36 Then
							Text 685,205,"Makrofag-Pool"
							Text 695,215,"2000 Proteine"
							Text 672,260,"Der Pool kann Makrofags"
							Text 672,270,"heranmutieren lassen."
							If MHitR Then BuildBuilding(EntityX#(U\Mesh),EntityZ#(U\Mesh),1,1200,1,3500,"000100000")
						End If
						DrawImage MiniPics(2),755,85
						If MX>755 And MX<755+36 And MY>85 And MY<85+36 Then
							Text 685,205,"Slicer-Dom"
							Text 695,215,"1500 Proteine"
							Text 672,260,"Der Dom kann Slicer"
							Text 672,270,"erzeugen."
							If MHitR Then BuildBuilding(EntityX#(U\Mesh),EntityZ#(U\Mesh),1,1200,0,3500,"010000000")
						End If
					End If
				Case 2
					If U\Picked=1
						DrawImage MiniPics(6),665,125
						If MX>665 And MX<665+36 And MY>125 And MY<125+36 Then
							Text 685,205,"Proteinfabrik"
							Text 695,215,"Passiv"
							Text 672,260,"Erzeugt alle zehn"
							Text 672,270,"Sekunden fnf Proteine."
						End If
					End If
					Skill_CreateProtein(U.Unit)
				Case 3
					If U\Picked=1
						DrawImage MiniPics(7),710,125
						If MX>710 And MX<710+36 And MY>125 And MY<125+36 Then
							Text 685,205,"Regeneration"
							Text 695,215,"Passiv"
							Text 672,260,"Regeneriert langsam"
							Text 672,270,"die Lebenspunkte."
						End If
					End If
					Skill_Weakregeneration (U.Unit)
				Case 4
					If U\Picked=1
						DrawImage MiniPics(8),755,125
						If MX>755 And MX<755+36 And MY>125 And MY<125+36 Then
							Text 685,205,"Aura des Lebens"
							Text 695,215,"Passiv"
							Text 672,260,"Regeneriert zgig die"
							Text 672,270,"Lebenspunkte von befreund-"
							Text 672,280,"eten Einheiten. Kleines Gebiet"
						End If
					End If
					Skill_AoEHeal(U.Unit)
		Case 5
			If U\Picked=1
				DrawImage MiniPics(9),665,165
				If MX>665 And MX<665+36 And MY>165 And MY<165+36 Then
					Text 685,205,"Wirbelwind"
					Text 695,215,"Aktiv"
					Text 672,260,"Die Einheit wirbelt umher,"
					Text 672,270,"schadet dabei sich und nahe"
					Text 672,280,"Einheiten"
					If MHitR Skill_Wind(U.Unit)
				End If
			End If
		Case 6
			If U\Picked=1
				DrawImage MiniPics(10),710,165
				If MX>710 And MX<710+36 And MY>165 And MY<165+36 Then
					Text 685,205,"Schlsselfigur"
					Text 695,215,"Passiv"
					Text 672,260,"Die Einheit ist eine "
					Text 672,270,"Schlsselfigur. Sind alle"
					Text 672,280,"tot, ist das Spiel zu Ende."
					End If
				End If
				Skill_KeyUnit(U\Owner)
		End Select
	EndIf
Next
End If
Next
	;wenn gedrckt, zeichnen
	If MDown=1 Then
		Rect StartX,StartY,MX-StartX,MY-StartY,0
	End If
	;wenn gerade losgelassen wird
	If MDown=0 And Hold=1 And MX<655
		Drawn=NoPic
		HP=0
		MaxHP=0
		For U.Unit=Each Unit
			CameraProject Camera,EntityX(U\Mesh),EntityY(U\Mesh),EntityZ(U\Mesh)
			If U\Picked=1 And U\Owner=P\ID Then
				U\Picked=0
			End If
			If ProjectedX#()>StartX
				If ProjectedX#()<MX
					If ProjectedY#()>StartY
						If ProjectedY#()<MY
							If U\Owner=P\ID
								U\Picked=1
							Drawn=Pics(U\Sort)
						End If
						End If
					End If
				End If
			End If
		Next
		For B.Building=Each Building
			CameraProject Camera,EntityX(B\Mesh),EntityY(B\Mesh),EntityZ(B\Mesh)
			If B\Picked=1 And B\Owner=P\ID Then
				B\Picked=0
			End If
			If ProjectedX#()>StartX
				If ProjectedX#()<MX
					If ProjectedY#()>StartY
						If ProjectedY#()<MY
							If B\Owner=P\ID
								B\Picked=1
							End If
						End If
					End If
				End If
			End If
		Next
	End If
	;wenn nichtmehr gedrckt
	If MDown=0 Then Hold=0
	;Befehl geben
	If MHitR And MX<650 Then
		For U.Unit=Each Unit
			If U\Picked=1
				CameraPick (Camera,MX,MY)
				Select PickedEntity()
					Case Plane
						Order_ForceMove(U.Unit,PickedX#(),PickedZ#())
				End Select
		End If
		Next
	End If
	Text 0,10,"Tipp: "+Tips$(TipCounter)
	If MilliSecs()-TipCD>25000 Then TipCounter=TipCounter+1:TipCD=MilliSecs()
	If TipCounter=8 Then TipCounter=0
	Text 670,60,"Proteine:  "+P\Protein
	Text 400,200,"Victory:  "+P\Victory
	Flip 0
	WaitTimer Timer
	
	For P.Player=Each Player
		If P\Victory=1 And P\ID=1 Then RuntimeError "Lost, noob!"
		P\Victory=1
	Next
Wend
End
Type Player
	Field ID,Protein,Name$,Victory
End Type
Type Unit
	Field Mesh,Hitpoints#,MaxHitpoints#,Damage,Movespeed#,Picked,Target,Sort,AnimationMode,Owner,Attack,ForceCommand,Inv,Dead,Range,Ring,Bone,Skill$,ID
End Type
Type Building
	Field Mesh,Hitpoints#,MaxHitpoints#,Spawn$,Owner,Picked,ID,Dead
End Type
Function SpawnUnit(OwnerID,X#,Y#,Cost,Mesh,HP,Damage,Speed#,Scale#=1,Skill$=000000000,Instant=0)
	P.Player=Object.Player(OwnerID)
	If P\Protein>=Cost
		U.Unit=New Unit
		U\Owner=OwnerID
		U\ID%=UnitID%
		UnitID%=UnitID%+1
		U\Mesh=CopyEntity(Units(Mesh))
		U\Target=CreatePivot()
		U\MaxHitpoints#=HP
		If Instant=1 Then U\Hitpoints=HP
		U\Damage=Damage
		U\Movespeed#=Speed#
		PositionEntity U\Mesh,X#,0,Y#
		PositionEntity U\Target,X#,0,Y#
		ScaleEntity U\Mesh,Scale#,Scale#,Scale#
		EntityType U\Mesh,1
		U\Sort=Mesh
		U\Skill$=Skill$
		U\Ring=CopyEntity (Ring,U\Mesh)
		TempS#=MeshDepth(U\Mesh)*0.5
		EntityAlpha U\Mesh,0
		EntityAlpha U\Ring,0
		U\Dead=-1
		ScaleEntity U\Ring,TempS#,TempS#,TempS#
		TranslateEntity U\Ring,0,0.05,0
		Select U\Owner
			Case 1
				EntityColor U\Ring,20,255,20
			Case 2
				EntityColor U\Ring,255,20,20
		End Select
		P\Protein=P\Protein-Cost
		U\Range=4
	End If
End Function
Function BuildBuilding(X#,Z#,ID,Cost,Mesh,HP,Spawn$)
	P.Player=Object.Player(ID)
	If P\Protein>=Cost
	B.Building=New Building
	B\ID=BuildingID
	BuildingID%=BuildingID%+1
	B\Owner=ID
	B\Mesh=CopyEntity(Buildings(Mesh))
	B\Dead=-1
	B\MaxHitpoints#=HP
	PositionEntity B\Mesh,X#,-10,Z#
	B\Spawn$=Spawn
	P\Protein=P\Protein-Cost
End If
End Function
Function Skill_CreateProtein(U.Unit)
	P.Player=Object.Player(U\Owner)
	If MilliSecs()-U\Inv>10000 Then U\Inv=MilliSecs():P\Protein=P\Protein+5
End Function
Function Skill_Weakregeneration(U.Unit)
	If MilliSecs()-U\Inv>500 Then 
		U\Inv=MilliSecs()
		If U\Hitpoints<U\MaxHitpoints Then U\Hitpoints=U\Hitpoints+1
	End If
End Function
Function Skill_Wind(U.Unit)
	If MilliSecs()-U\Inv>3000 Then 
		U\Inv=MilliSecs()
		U\Hitpoints=U\Hitpoints*0.8
		For U2.Unit=Each Unit
			If EntityDistance (U\Mesh,U2\Mesh)<7 And U\ID<>U2\ID Then U2\Hitpoints=U2\Hitpoints-125
		Next
		Animate U\Mesh,3,0.3,4,1
	End If
End Function
Function Skill_AoEHeal(U.Unit)
	If MilliSecs()-U\Inv>500 Then 
		U\Inv=MilliSecs()
		For U2.Unit=Each Unit
			If EntityDistance (U\Mesh,U2\Mesh)<10 And U\Owner=U2\Owner And U2\Hitpoints<U2\MaxHitpoints Then U2\Hitpoints=U2\Hitpoints+1
		Next
	End If
End Function
Function Order_Move(U.Unit,X#,Y#)
	PositionEntity U\Target,X#,0,Y#
	U\Attack=0
	For U2.Unit=Each Unit
		If EntityDistance(U\Target,U2\Mesh)<3 Then U\ForceCommand=0
	Next
End Function
Function Order_ForceMove(U.Unit,X#,Y#)
	PositionEntity U\Target,X#,0,Y#
	U\Attack=0
	U\ForceCommand=1
	For U2.Unit=Each Unit
		If EntityDistance(U\Target,U2\Mesh)<3 Then U\ForceCommand=0
	Next
End Function

Function Skill_KeyUnit(PlayerID)
	P.Player=Object.Player(PlayerID)
	P\Victory=0
End Function
;~IDEal Editor Parameters:
;~F#1EF#1F2#219#228#22C#232#23C#244#24B
;~C#Blitz3D